'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = gulpTransform;

var _lodash = require('lodash');

var _pluginStream = require('./plugin-stream');

var _err = require('./err');

function gulpTransform(transformFn, options) {
  if ((0, _lodash.isNil)(transformFn)) {
    (0, _err.err)('transformFn must be defined');
  } else if (!(0, _lodash.isFunction)(transformFn)) {
    (0, _err.err)('transformFn must be a function');
  } else if (!(0, _lodash.isNil)(options) && !(0, _lodash.isObject)(options)) {
    (0, _err.err)('options must be an object');
  } else {
    return new _pluginStream.PluginStream(transformFn, options);
  }
}
module.exports = exports['default'];