'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = transform;

var _lodash = require('lodash');

var _err = require('./err');

function transform(fn, contents, file, opts) {
  var encoded = opts.encoding ? contents.toString(opts.encoding) : contents;
  var transformed = fn.call(opts.thisArg, encoded, file);

  return (0, _lodash.isBuffer)(transformed) ? transformed : (0, _lodash.isString)(transformed) ? new Buffer(transformed) : (0, _err.err)('transformFn must return a string or a Buffer');
}